/*****************************************************************
random numbers in 1st column

$Id: randhead.c,v 1.1.1.1 1998/12/29 21:26:36 purnhage Exp $

Source file: randhead.c

Authors:
HP    Heiko Purnhagen, Uni Hannover <purnhage@tnt.uni-hannover.de>

Changes:
18-mar-94   HP      first version written at NTH
13-oct-98   HP      own random, randomize, seed
**********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/times.h>


#define MAXLEN 256

#define MY_RAND_MAX 0x7fffffff

char prog[] = "randhead";

FILE *infile;
int linenum = 0;
char linebuf[MAXLEN+1];
int addmode;

long randx = 1;		/* default seed */


/* random1() */
/* Generate random long (uniform distribution 0..RND_MAX). */

long myrandom (void)
{
  randx = (randx * 1103515245) + 12345;
  return (randx & MY_RAND_MAX);
}


/* main() */

int main (int argc, char *argv[])
{
  int i;
  
  if (argc != 2 && argc != 3) {
    fprintf (stderr,
	     "Usage: %s mode [infile]\n"
	     "mode '+' : add random numbers as 1st column (random seed)\n"
	     "mode 'nn': add random numbers as 1st column (seed nn)\n"
	     "mode '-' : remove 1st column\n"
	     ,prog);
    exit (1);
  }

  if ((addmode=(argv[1][0] != '-'))) {
    if (argv[1][0] == '+') {
      randx = (long)times(NULL);
    }
    else
      randx = atoi(argv[1]);
  }
  if (argc == 3) {
    if ((infile = fopen(argv[2],"r")) == NULL) {
      fprintf (stderr,"%s: can't open %s\n",prog,argv[2]);
      exit (2);
    }
  }
  else
    infile = stdin;

  while (fgets(linebuf,MAXLEN,infile) != NULL) {
    linenum++;
    if (addmode) {
      printf ("%7ld %s",myrandom() % 10000000,linebuf);
    }
    else {
      i = 0;
      while (linebuf[i] == ' ' || linebuf[i] == '\t')
	i++;
      while (linebuf[i] != ' ' && linebuf[i] != '\t' &&
	     linebuf[i] != '\0' && linebuf[i] != '\n')
	i++;
      while (linebuf[i] == ' ' || linebuf[i] == '\t')
	i++;
      printf ("%s",linebuf+i);
    }
  }

  fclose (infile);
  exit (0);
}

/* end of randhead.c */
